Subject: linux-next: manual merge of the tip tree with the mm-unstable tree

From: Stephen Rothwell <[email-masked]>
Date: Thu, 10 Jul 2025 14:30:52 +1000

Hi all,

Today's linux-next merge of the tip tree got a conflict in:

  mm/vmstat.c

between commit:

  954386324a11 ("mm/vmstat: utilize designated initializers for the vmstat_text array")

from the mm-unstable tree and commit:

  8662a3e5e9c4 ("Revert "sched/numa: add statistics of numa balance task"")

from the tip tree.

I fixed it up (see below - search for NUMA_BALANCING) and can carry the
fix as necessary. This is now fixed as far as linux-next is concerned,
but any non trivial conflicts should be mentioned to your upstream
maintainer when your tree is submitted for merging.  You may also want
to consider cooperating with the maintainer of the conflicting tree to
minimise any particularly complex conflicts.

I assume that this will go away when the Revert above goes into Linus'
tree (or returns to the mm-hotfixes tre).
-- 
Cheers,
Stephen Rothwell

diff --cc mm/vmstat.c
index e0fcd9057f34,a78d70ddeacd..000000000000
--- a/mm/vmstat.c
+++ b/mm/vmstat.c
@@@ -1196,195 -1192,178 +1196,193 @@@ int fragmentation_index(struct zone *zo
  
  const char * const vmstat_text[] = {
  	/* enum zone_stat_item counters */
 -	"nr_free_pages",
 -	"nr_free_pages_blocks",
 -	"nr_zone_inactive_anon",
 -	"nr_zone_active_anon",
 -	"nr_zone_inactive_file",
 -	"nr_zone_active_file",
 -	"nr_zone_unevictable",
 -	"nr_zone_write_pending",
 -	"nr_mlock",
 +#define I(x) (x)
 +	[I(NR_FREE_PAGES)]			= "nr_free_pages",
 +	[I(NR_FREE_PAGES_BLOCKS)]		= "nr_free_pages_blocks",
 +	[I(NR_ZONE_INACTIVE_ANON)]		= "nr_zone_inactive_anon",
 +	[I(NR_ZONE_ACTIVE_ANON)]		= "nr_zone_active_anon",
 +	[I(NR_ZONE_INACTIVE_FILE)]		= "nr_zone_inactive_file",
 +	[I(NR_ZONE_ACTIVE_FILE)]		= "nr_zone_active_file",
 +	[I(NR_ZONE_UNEVICTABLE)]		= "nr_zone_unevictable",
 +	[I(NR_ZONE_WRITE_PENDING)]		= "nr_zone_write_pending",
 +	[I(NR_MLOCK)]				= "nr_mlock",
  #if IS_ENABLED(CONFIG_ZSMALLOC)
 -	"nr_zspages",
 +	[I(NR_ZSPAGES)]				= "nr_zspages",
  #endif
 -	"nr_free_cma",
 +	[I(NR_FREE_CMA_PAGES)]			= "nr_free_cma",
  #ifdef CONFIG_UNACCEPTED_MEMORY
 -	"nr_unaccepted",
 +	[I(NR_UNACCEPTED)]			= "nr_unaccepted",
  #endif
 +#undef I
  
  	/* enum numa_stat_item counters */
 +#define I(x) (NR_VM_ZONE_STAT_ITEMS + x)
  #ifdef CONFIG_NUMA
 -	"numa_hit",
 -	"numa_miss",
 -	"numa_foreign",
 -	"numa_interleave",
 -	"numa_local",
 -	"numa_other",
 +	[I(NUMA_HIT)]				= "numa_hit",
 +	[I(NUMA_MISS)]				= "numa_miss",
 +	[I(NUMA_FOREIGN)]			= "numa_foreign",
 +	[I(NUMA_INTERLEAVE_HIT)]		= "numa_interleave",
 +	[I(NUMA_LOCAL)]				= "numa_local",
 +	[I(NUMA_OTHER)]				= "numa_other",
  #endif
 +#undef I
  
  	/* enum node_stat_item counters */
 -	"nr_inactive_anon",
 -	"nr_active_anon",
 -	"nr_inactive_file",
 -	"nr_active_file",
 -	"nr_unevictable",
 -	"nr_slab_reclaimable",
 -	"nr_slab_unreclaimable",
 -	"nr_isolated_anon",
 -	"nr_isolated_file",
 -	"workingset_nodes",
 -	"workingset_refault_anon",
 -	"workingset_refault_file",
 -	"workingset_activate_anon",
 -	"workingset_activate_file",
 -	"workingset_restore_anon",
 -	"workingset_restore_file",
 -	"workingset_nodereclaim",
 -	"nr_anon_pages",
 -	"nr_mapped",
 -	"nr_file_pages",
 -	"nr_dirty",
 -	"nr_writeback",
 -	"nr_writeback_temp",
 -	"nr_shmem",
 -	"nr_shmem_hugepages",
 -	"nr_shmem_pmdmapped",
 -	"nr_file_hugepages",
 -	"nr_file_pmdmapped",
 -	"nr_anon_transparent_hugepages",
 -	"nr_vmscan_write",
 -	"nr_vmscan_immediate_reclaim",
 -	"nr_dirtied",
 -	"nr_written",
 -	"nr_throttled_written",
 -	"nr_kernel_misc_reclaimable",
 -	"nr_foll_pin_acquired",
 -	"nr_foll_pin_released",
 -	"nr_kernel_stack",
 +#define I(x) (NR_VM_ZONE_STAT_ITEMS + NR_VM_NUMA_EVENT_ITEMS + x)
 +	[I(NR_INACTIVE_ANON)]			= "nr_inactive_anon",
 +	[I(NR_ACTIVE_ANON)]			= "nr_active_anon",
 +	[I(NR_INACTIVE_FILE)]			= "nr_inactive_file",
 +	[I(NR_ACTIVE_FILE)]			= "nr_active_file",
 +	[I(NR_UNEVICTABLE)]			= "nr_unevictable",
 +	[I(NR_SLAB_RECLAIMABLE_B)]		= "nr_slab_reclaimable",
 +	[I(NR_SLAB_UNRECLAIMABLE_B)]		= "nr_slab_unreclaimable",
 +	[I(NR_ISOLATED_ANON)]			= "nr_isolated_anon",
 +	[I(NR_ISOLATED_FILE)]			= "nr_isolated_file",
 +	[I(WORKINGSET_NODES)]			= "workingset_nodes",
 +	[I(WORKINGSET_REFAULT_ANON)]		= "workingset_refault_anon",
 +	[I(WORKINGSET_REFAULT_FILE)]		= "workingset_refault_file",
 +	[I(WORKINGSET_ACTIVATE_ANON)]		= "workingset_activate_anon",
 +	[I(WORKINGSET_ACTIVATE_FILE)]		= "workingset_activate_file",
 +	[I(WORKINGSET_RESTORE_ANON)]		= "workingset_restore_anon",
 +	[I(WORKINGSET_RESTORE_FILE)]		= "workingset_restore_file",
 +	[I(WORKINGSET_NODERECLAIM)]		= "workingset_nodereclaim",
 +	[I(NR_ANON_MAPPED)]			= "nr_anon_pages",
 +	[I(NR_FILE_MAPPED)]			= "nr_mapped",
 +	[I(NR_FILE_PAGES)]			= "nr_file_pages",
 +	[I(NR_FILE_DIRTY)]			= "nr_dirty",
 +	[I(NR_WRITEBACK)]			= "nr_writeback",
 +	[I(NR_SHMEM)]				= "nr_shmem",
 +	[I(NR_SHMEM_THPS)]			= "nr_shmem_hugepages",
 +	[I(NR_SHMEM_PMDMAPPED)]			= "nr_shmem_pmdmapped",
 +	[I(NR_FILE_THPS)]			= "nr_file_hugepages",
 +	[I(NR_FILE_PMDMAPPED)]			= "nr_file_pmdmapped",
 +	[I(NR_ANON_THPS)]			= "nr_anon_transparent_hugepages",
 +	[I(NR_VMSCAN_WRITE)]			= "nr_vmscan_write",
 +	[I(NR_VMSCAN_IMMEDIATE)]		= "nr_vmscan_immediate_reclaim",
 +	[I(NR_DIRTIED)]				= "nr_dirtied",
 +	[I(NR_WRITTEN)]				= "nr_written",
 +	[I(NR_THROTTLED_WRITTEN)]		= "nr_throttled_written",
 +	[I(NR_KERNEL_MISC_RECLAIMABLE)]		= "nr_kernel_misc_reclaimable",
 +	[I(NR_FOLL_PIN_ACQUIRED)]		= "nr_foll_pin_acquired",
 +	[I(NR_FOLL_PIN_RELEASED)]		= "nr_foll_pin_released",
 +	[I(NR_KERNEL_STACK_KB)]			= "nr_kernel_stack",
  #if IS_ENABLED(CONFIG_SHADOW_CALL_STACK)
 -	"nr_shadow_call_stack",
 +	[I(NR_KERNEL_SCS_KB)]			= "nr_shadow_call_stack",
  #endif
 -	"nr_page_table_pages",
 -	"nr_sec_page_table_pages",
 +	[I(NR_PAGETABLE)]			= "nr_page_table_pages",
 +	[I(NR_SECONDARY_PAGETABLE)]		= "nr_sec_page_table_pages",
  #ifdef CONFIG_IOMMU_SUPPORT
 -	"nr_iommu_pages",
 +	[I(NR_IOMMU_PAGES)]			= "nr_iommu_pages",
  #endif
  #ifdef CONFIG_SWAP
 -	"nr_swapcached",
 +	[I(NR_SWAPCACHE)]			= "nr_swapcached",
  #endif
  #ifdef CONFIG_NUMA_BALANCING
 -	"pgpromote_success",
 -	"pgpromote_candidate",
 +	[I(PGPROMOTE_SUCCESS)]			= "pgpromote_success",
 +	[I(PGPROMOTE_CANDIDATE)]		= "pgpromote_candidate",
  #endif
 -	"pgdemote_kswapd",
 -	"pgdemote_direct",
 -	"pgdemote_khugepaged",
 -	"pgdemote_proactive",
 +	[I(PGDEMOTE_KSWAPD)]			= "pgdemote_kswapd",
 +	[I(PGDEMOTE_DIRECT)]			= "pgdemote_direct",
 +	[I(PGDEMOTE_KHUGEPAGED)]		= "pgdemote_khugepaged",
 +	[I(PGDEMOTE_PROACTIVE)]			= "pgdemote_proactive",
  #ifdef CONFIG_HUGETLB_PAGE
 -	"nr_hugetlb",
 +	[I(NR_HUGETLB)]				= "nr_hugetlb",
  #endif
 -	"nr_balloon_pages",
 +	[I(NR_BALLOON_PAGES)]			= "nr_balloon_pages",
 +#undef I
 +
  	/* system-wide enum vm_stat_item counters */
 -	"nr_dirty_threshold",
 -	"nr_dirty_background_threshold",
 -	"nr_memmap_pages",
 -	"nr_memmap_boot_pages",
 +#define I(x) (NR_VM_ZONE_STAT_ITEMS + NR_VM_NUMA_EVENT_ITEMS + \
 +	     NR_VM_NODE_STAT_ITEMS + x)
 +	[I(NR_DIRTY_THRESHOLD)]			= "nr_dirty_threshold",
 +	[I(NR_DIRTY_BG_THRESHOLD)]		= "nr_dirty_background_threshold",
 +	[I(NR_MEMMAP_PAGES)]			= "nr_memmap_pages",
 +	[I(NR_MEMMAP_BOOT_PAGES)]		= "nr_memmap_boot_pages",
 +#undef I
  
 -#if defined(CONFIG_VM_EVENT_COUNTERS) || defined(CONFIG_MEMCG)
 +#if defined(CONFIG_VM_EVENT_COUNTERS)
  	/* enum vm_event_item counters */
 -	"pgpgin",
 -	"pgpgout",
 -	"pswpin",
 -	"pswpout",
 +#define I(x) (NR_VM_ZONE_STAT_ITEMS + NR_VM_NUMA_EVENT_ITEMS + \
 +	     NR_VM_NODE_STAT_ITEMS + NR_VM_STAT_ITEMS + x)
  
 -	TEXTS_FOR_ZONES("pgalloc")
 -	TEXTS_FOR_ZONES("allocstall")
 -	TEXTS_FOR_ZONES("pgskip")
 +	[I(PGPGIN)]				= "pgpgin",
 +	[I(PGPGOUT)]				= "pgpgout",
 +	[I(PSWPIN)]				= "pswpin",
 +	[I(PSWPOUT)]				= "pswpout",
  
 -	"pgfree",
 -	"pgactivate",
 -	"pgdeactivate",
 -	"pglazyfree",
 +#define OFF (NR_VM_ZONE_STAT_ITEMS + NR_VM_NUMA_EVENT_ITEMS + \
 +	     NR_VM_NODE_STAT_ITEMS + NR_VM_STAT_ITEMS)
 +	TEXTS_FOR_ZONES(OFF+PGALLOC, "pgalloc")
 +	TEXTS_FOR_ZONES(OFF+ALLOCSTALL, "allocstall")
 +	TEXTS_FOR_ZONES(OFF+PGSCAN_SKIP, "pgskip")
 +#undef OFF
  
 -	"pgfault",
 -	"pgmajfault",
 -	"pglazyfreed",
 +	[I(PGFREE)]				= "pgfree",
 +	[I(PGACTIVATE)]				= "pgactivate",
 +	[I(PGDEACTIVATE)]			= "pgdeactivate",
 +	[I(PGLAZYFREE)]				= "pglazyfree",
  
 -	"pgrefill",
 -	"pgreuse",
 -	"pgsteal_kswapd",
 -	"pgsteal_direct",
 -	"pgsteal_khugepaged",
 -	"pgsteal_proactive",
 -	"pgscan_kswapd",
 -	"pgscan_direct",
 -	"pgscan_khugepaged",
 -	"pgscan_proactive",
 -	"pgscan_direct_throttle",
 -	"pgscan_anon",
 -	"pgscan_file",
 -	"pgsteal_anon",
 -	"pgsteal_file",
 +	[I(PGFAULT)]				= "pgfault",
 +	[I(PGMAJFAULT)]				= "pgmajfault",
 +	[I(PGLAZYFREED)]			= "pglazyfreed",
 +
 +	[I(PGREFILL)]				= "pgrefill",
 +	[I(PGREUSE)]				= "pgreuse",
 +	[I(PGSTEAL_KSWAPD)]			= "pgsteal_kswapd",
 +	[I(PGSTEAL_DIRECT)]			= "pgsteal_direct",
 +	[I(PGSTEAL_KHUGEPAGED)]			= "pgsteal_khugepaged",
 +	[I(PGSTEAL_PROACTIVE)]			= "pgsteal_proactive",
 +	[I(PGSCAN_KSWAPD)]			= "pgscan_kswapd",
 +	[I(PGSCAN_DIRECT)]			= "pgscan_direct",
 +	[I(PGSCAN_KHUGEPAGED)]			= "pgscan_khugepaged",
 +	[I(PGSCAN_PROACTIVE)]			= "pgscan_proactive",
 +	[I(PGSCAN_DIRECT_THROTTLE)]		= "pgscan_direct_throttle",
 +	[I(PGSCAN_ANON)]			= "pgscan_anon",
 +	[I(PGSCAN_FILE)]			= "pgscan_file",
 +	[I(PGSTEAL_ANON)]			= "pgsteal_anon",
 +	[I(PGSTEAL_FILE)]			= "pgsteal_file",
  
  #ifdef CONFIG_NUMA
 -	"zone_reclaim_success",
 -	"zone_reclaim_failed",
 +	[I(PGSCAN_ZONE_RECLAIM_SUCCESS)]	= "zone_reclaim_success",
 +	[I(PGSCAN_ZONE_RECLAIM_FAILED)]		= "zone_reclaim_failed",
  #endif
 -	"pginodesteal",
 -	"slabs_scanned",
 -	"kswapd_inodesteal",
 -	"kswapd_low_wmark_hit_quickly",
 -	"kswapd_high_wmark_hit_quickly",
 -	"pageoutrun",
 +	[I(PGINODESTEAL)]			= "pginodesteal",
 +	[I(SLABS_SCANNED)]			= "slabs_scanned",
 +	[I(KSWAPD_INODESTEAL)]			= "kswapd_inodesteal",
 +	[I(KSWAPD_LOW_WMARK_HIT_QUICKLY)]	= "kswapd_low_wmark_hit_quickly",
 +	[I(KSWAPD_HIGH_WMARK_HIT_QUICKLY)]	= "kswapd_high_wmark_hit_quickly",
 +	[I(PAGEOUTRUN)]				= "pageoutrun",
  
 -	"pgrotated",
 +	[I(PGROTATED)]				= "pgrotated",
  
 -	"drop_pagecache",
 -	"drop_slab",
 -	"oom_kill",
 +	[I(DROP_PAGECACHE)]			= "drop_pagecache",
 +	[I(DROP_SLAB)]				= "drop_slab",
 +	[I(OOM_KILL)]				= "oom_kill",
  
  #ifdef CONFIG_NUMA_BALANCING
 -	"numa_pte_updates",
 -	"numa_huge_pte_updates",
 -	"numa_hint_faults",
 -	"numa_hint_faults_local",
 -	"numa_pages_migrated",
 +	[I(NUMA_PTE_UPDATES)]			= "numa_pte_updates",
 +	[I(NUMA_HUGE_PTE_UPDATES)]		= "numa_huge_pte_updates",
 +	[I(NUMA_HINT_FAULTS)]			= "numa_hint_faults",
 +	[I(NUMA_HINT_FAULTS_LOCAL)]		= "numa_hint_faults_local",
 +	[I(NUMA_PAGE_MIGRATE)]			= "numa_pages_migrated",
- 	[I(NUMA_TASK_MIGRATE)]			= "numa_task_migrated",
- 	[I(NUMA_TASK_SWAP)]			= "numa_task_swapped",
  #endif
  #ifdef CONFIG_MIGRATION
 -	"pgmigrate_success",
 -	"pgmigrate_fail",
 -	"thp_migration_success",
 -	"thp_migration_fail",
 -	"thp_migration_split",
 +	[I(PGMIGRATE_SUCCESS)]			= "pgmigrate_success",
 +	[I(PGMIGRATE_FAIL)]			= "pgmigrate_fail",
 +	[I(THP_MIGRATION_SUCCESS)]		= "thp_migration_success",
 +	[I(THP_MIGRATION_FAIL)]			= "thp_migration_fail",
 +	[I(THP_MIGRATION_SPLIT)]		= "thp_migration_split",
  #endif
  #ifdef CONFIG_COMPACTION
 -	"compact_migrate_scanned",
 -	"compact_free_scanned",
 -	"compact_isolated",
 -	"compact_stall",
 -	"compact_fail",
 -	"compact_success",
 -	"compact_daemon_wake",
 -	"compact_daemon_migrate_scanned",
 -	"compact_daemon_free_scanned",
 +	[I(COMPACTMIGRATE_SCANNED)]		= "compact_migrate_scanned",
 +	[I(COMPACTFREE_SCANNED)]		= "compact_free_scanned",
 +	[I(COMPACTISOLATED)]			= "compact_isolated",
 +	[I(COMPACTSTALL)]			= "compact_stall",
 +	[I(COMPACTFAIL)]			= "compact_fail",
 +	[I(COMPACTSUCCESS)]			= "compact_success",
 +	[I(KCOMPACTD_WAKE)]			= "compact_daemon_wake",
 +	[I(KCOMPACTD_MIGRATE_SCANNED)]		= "compact_daemon_migrate_scanned",
 +	[I(KCOMPACTD_FREE_SCANNED)]		= "compact_daemon_free_scanned",
  #endif
  
  #ifdef CONFIG_HUGETLB_PAGE